#include <stdio.h>
#include "rainbowtables.h"
#include "random.h"
#include "md5.h"
#define MAX 100
#define FILE_NAME1 "nastavenia.txt"
#define FILE_NAME2 "parametre.txt"
#define FILE_NAME3 "prehladavanie.txt"

int n;
int project_exists;
unsigned char hash[3];
unsigned char f_str [TABLE_NAME_LENGTH];
char *fname = f_str;

int prog_max, prog_count; //progressBar 
int prog_i;           // value from 0..20

int keynum = 0;

static void loadTableName(TableInfo *ti);
static void showParameters(TableInfo* ti);
static void reportParametersProblem(int errnum);

static void encode(void* key, void* hash)
{       
       md5_state_t state;
       unsigned char  a [16];
   	   md5_init(&state);
       md5_append(&state, key, 3);	
   	   md5_finish(&state, a);
   	   memcpy(hash, a, 3);   	   
}

static void reduce(void* hash, int i, void* key)
{       
       memcpy(key, hash, 3);
       unsigned char* key2 = key;
       key2[0] = (key2[0] + i);
       i = i >> 8;
       key2[1] = (key2[1] + i);
       i = i >> 8;
       key2[2] = (key2[2] + i);
}

static void genKey(void *key2)
{
       unsigned char* key = key2;
       int x = keynum;
       key[0] = keynum;
       keynum = keynum >> 8;
       key[1] = keynum;
       keynum = keynum >> 8;
       key[2] = keynum;
       keynum = x+1;
}

static void lowerCase(char* s)
{
       if (s == NULL) return;
       int i = -1;
       while (s[++i]!=0) {
             if (isupper(s[i])) { 
                s[i] = (char) tolower(s[i]);
             }
       }       
}

static void printLine()
{
       int i;
       printf("\n");
       for (i=0; i<60; i++) printf("*");
       printf("\n\n");
}

static int getPos(char* s, char c)
{
       int result = 0;
       while ( (s[result]) && (s[result] != c) ) 
             result++;
       if (! s[result]) 
          result = -1;
       return result;
}

static void resetTableInfo(TableInfo* ti)
{
       ti->hash_size = ti->key_size = 24;
       strcpy(ti->table_name, "");
       ti->limit1 = 1;
       ti->limit2 = 1;
       ti->table_size = 0;
       ti->array_size  = 0;
       ti->strict_dupl_detection = 0;
       ti->remove_duplicates = 0;
       ti->chain_length = 1;
       ti->lookups_on = 0;
       ti->lookups = 0;
       
       ti->fEncode = &encode;
       ti->fReduce = &reduce;
       ti->fCompare = NULL;
       ti->fGenerateKey = NULL;
}

static int fileExists(char *file_name)
{
       FILE *pFile;
       int result;
       result = ((pFile = fopen(file_name, "r")) != NULL);
       if (result) fclose(pFile);
       return result;
}

static int loadFromFile(TableInfo* ti, char* file_name)
{
       unsigned char c [MAX];
       unsigned char var_name [30];  // name of variable from TableInfo
       unsigned char value [30];     // value of variable var_name
       int i;
       int line_counter = 0;
       int str_len, high;
     	 FILE *pFile;
     	 if ((pFile = fopen(file_name, "r")) == NULL)
     	    { perror( "fopen" ); return;	}
  	   while ( (fgets(c, MAX, pFile)) != NULL ){
             line_counter++;
             if ((i = getPos(c, ' ')) == -1) { 
                printf("error on line %d\n", line_counter);
                return -1;
             }
             high = strlen(c) - 1;
             if (c[high] == 10) c[high--] = 0; // removes next line
             if (c[high] == 13) c[high--] = 0;  // removes next line
             high++; // high is length of string without marks for next line
             
             memcpy(var_name, c, i); var_name[i] = 0;
             str_len = strlen(var_name);
             lowerCase(var_name);              
             memcpy(value, c + str_len + 3, high - str_len - 3); // 3 stands for " = "
             value[high - str_len - 3] = 0;
             if (! strcmp(var_name, "table_name")) {
                strcpy(ti->table_name, value);                
             }
             if (! strcmp(var_name, "table_size")) {
                ti->table_size = atoi(value);
             }
             if (! strcmp(var_name, "chain_length")) {
                ti->chain_length = atoi(value);
             }
             if (! strcmp(var_name, "array_size")) {
                ti->array_size = atoi(value);
             }
             if (! strcmp(var_name, "remove_duplicates")) {
                ti->remove_duplicates= atoi(value);
             }
             if (! strcmp(var_name, "strict_dupl_detection")) {
                ti->strict_dupl_detection = atoi(value);
             }
             if (! strcmp(var_name, "limit1")) {
                ti->limit1 = atoi(value);
             }
             if (! strcmp(var_name, "limit2")) {
                ti->limit2 = atoi(value);
             }
             if (! strcmp(var_name, "lookups_on")) {
                ti->lookups_on = atoi(value);
             }
             if (! strcmp(var_name, "lookups")) {
                ti->lookups = atoi(value);
             }
       }
  	   fclose(pFile);
}

static void saveToFile(TableInfo* ti, char* file_name)
{
       FILE *pFile;
   	   if ((pFile = fopen(file_name, "w")) == NULL){
   	      printf("Error! File cannot be opened %s", file_name); 
          return;	
      }
  	   fprintf( pFile, "table_name = %s\n", ti->table_name);
  	   fprintf( pFile, "table_size = %d\n", ti->table_size);
  	   fprintf( pFile, "chain_length = %d\n", ti->chain_length);
  	   fprintf( pFile, "array_size = %d\n", ti->array_size);
  	   fprintf( pFile, "remove_duplicates = %d\n", ti->remove_duplicates);
  	   fprintf( pFile, "strict_dupl_detection = %d\n", ti->strict_dupl_detection);
  	   fprintf( pFile, "lookups_on = %d\n", ti->lookups_on);
  	   fprintf( pFile, "lookups = %d\n", ti->lookups);
  	   fprintf( pFile, "limit1 = %d\n", ti->limit1);
  	   fprintf( pFile, "limit2 = %d\n", ti->limit2);
  	   fclose(pFile);       
}


static void updateFileName(TableInfo *ti)
{
       strcpy(fname, ti->table_name);
       strcat(fname, SUF);       
}

static int titleScreen(TableInfo *ti)
{
       project_exists = 0;
       showParameters(ti);
       updateFileName(ti);
       printf("Vyberte si jednu z nasledujucich moznosti:\n\n");
       printf("0 - Ukoncit program\n");
       printf("1 - Nacitanie vstupnych parametrov zo suboru %s\n", FILE_NAME1);
       printf("2 - Zapisanie vstupnych parametrov do suboru %s\n", FILE_NAME1);
       printf("3 - Zadanie vstupnych parametrov rucne\n");
       printf("4 - Vytvoit tabulku\n");
       printf("5 - Ulozit parametre do suboru %s\n", FILE_NAME2);
       if ( ( fname != SUF ) && ( fileExists(fname) ) ){
          project_exists = 1;
          printf("6 - Zvacsit existujucu tabulku\n");
          printf("7 - Prehladavat tabulku\n");          
          printf("8 - Precitaj parametre tabulky\n");
       }
       scanf("%d", &n);
       system("cls");
       return n;
}

static void showParameters(TableInfo* ti)
{
       printf("Momentalne nastavene parametre: \n\n");
       printf("table_name    = %s\n", ti->table_name);
       printf("table_size    = %d\n", ti->table_size);
       printf("chain_length  = %d\n", ti->chain_length);
       printf("array_size    = %d\n", ti->array_size);
       printf("lookupsOn     = %d\n", ti->lookups_on);
       printf("lookups       = %d\n", ti->lookups);
       printf("limit1        = %d\n", ti->limit1);
       printf("limit2        = %d\n", ti->limit2);
       printf("strict_dupl_detection = %d\n", ti->strict_dupl_detection);
       printf("remove_duplicates     = %d\n", ti->remove_duplicates);
       printLine();
}

static int loadParameters(TableInfo* ti)
{
       printf("Ako chcete zadat parametre?\n\n");
       printf("0 - Spat\n");
       printf("1 - Vsetky naraz\n");
       printf("2 - Po jednom\n");
       scanf("%d", &n);
       system("cls");
       return n;
}

static void loadTableName(TableInfo *ti)
{
       unsigned char string[100];
       char *str = string;
       strcpy(ti->table_name, "");
       int notOK = 1;
       do {
          printf("table_name = ");
          scanf("%s", str);
          if (strlen(str)< TABLE_NAME_LENGTH){
             strcat(ti->table_name, str);
             notOK = 0;
          }
       } while(notOK);
}

static void loadAllParameters(TableInfo* ti)
{
       loadTableName(ti); 
       printf("table_size = ");
       scanf("%d", &(ti->table_size));
       printf("chain_length = ");
       scanf("%d", &(ti->chain_length));
       printf("array_size = ");
       scanf("%d", &(ti->array_size));
       printf("lookups_on = ");
       scanf("%d", &(ti->lookups_on));
       printf("lookups = ");
       scanf("%d", &(ti->lookups));
       printf("limit1 = ");
       scanf("%d", &(ti->limit1));
       printf("limit2 = ");
       scanf("%d", &(ti->limit2));
       printf("strict_dupl_detection = ");
       scanf("%d", &(ti->strict_dupl_detection));
       printf("remove_duplicates = ");
       scanf("%d", &(ti->remove_duplicates));
       system("cls");       
}

static void loadParametersByOne(TableInfo* ti)
{
       int a;
       do{
          showParameters(ti);
          printf("Vyberte parameter, ktory chcete zmenit\n\n");
          printf(" 0 - koniec\n");
          printf(" 1 - table_name\n");
          printf(" 2 - table_size\n");
          printf(" 3 - chain_length\n");
          printf(" 4 - array_size\n");
          printf(" 5 - lookupsOn\n");
          printf(" 6 - lookups\n");
          printf(" 7 - limit1\n");
          printf(" 8 - limit2\n");
          printf(" 9 - strict_dupl_detection\n");
          printf("10 - remove_duplicates\n");
          scanf("%d", &a);
          if (a==1) loadTableName(ti);
          switch (a) {
                 case 2:
                      printf("table_size = ");
                      scanf("%d", &(ti->table_size));
                      break;
                 case 3:
                      printf("chain_length = ");
                      scanf("%d", &(ti->chain_length));
                      break;
                 case 4:
                      printf("array_size = ");
                      scanf("%d", &(ti->array_size));
                      break;
                 case 5:
                      printf("lookups_on = ");
                      scanf("%d", &(ti->lookups_on));
                      break;
                 case 6:
                      printf("lookups = ");
                      scanf("%d", &(ti->lookups));
                      break;
                 case 7:
                      printf("limit1 = ");
                      scanf("%d", &(ti->limit1));
                      break;
                 case 8:
                      printf("limit2 = ");
                      scanf("%d", &(ti->limit2));
                      break;
                 case 9:
                      printf("strict_dupl_detection = ");
                      scanf("%d", &(ti->strict_dupl_detection));
                      break;
                 case 10:
                      printf("remove_duplicates = ");
                      scanf("%d", &(ti->remove_duplicates));
                      break;
          }
          
          system("cls");
       } while (a != 0);
}

static int checkParametersForCreate(TableInfo* ti)
{
       if (ti->table_name == "") return 1;
       if (ti->table_size < 1) return 2;
       if (ti->chain_length < 1) return 3;
       if (ti->array_size < 10) return 4;
       int a;
       if ( ( fname != SUF ) && ( fileExists(fname) ) ){
          printf("Tabulka s takymto nazvom uz existuje, chcete ju prepisat?\n\n");
          printf("1 - Ano\n");
          printf("2 - Nie\n");
          scanf("%d", &a);
          if (a==2) return 5;
       }
       return 0;
}

static int searchTableMenu(TableInfo* ti)
{
       int a;
       printf("Zadajte sposob prehladavania\n");
       printf("0 - Spat\n");
       printf("1 - Jeden hash (Momentalna hodnota je: %02x %02x %02x )\n", hash[0], hash[1], hash[2]);
       printf("2 - Zmenit hladany hash\n");
       printf("3 - N nahodnych hashov\n");
       scanf("%d", &a);
       system("cls");
       return a;
}

static void loadHash()
{
       int i;
       printf("Zadajte postupne tri cisla v rozsahu 0 - 255\n");
       for (i=0; i<3; i++){
           printf("cislo %d - ", i+1);
           scanf("%d", hash+i);
       }
       system("cls");
}

static void loadRandomHash()
{
      unsigned char a [3];
       randomN(a, 3);
       encode(a, hash);
//       randomN(hash, 3);
}

static int getNumber()
{
       int a, b;
       do {
          printf("Zadajte pocet retazi (pre zrusenie akcie zadajte 0): ");
          scanf("%d", &a);
          printf("Potvrdte lubovolnou nenulovou hodnotou: ");
          scanf("%d", &b);
          system("cls");
       } while ( b==0 );
       return a;
}

static void printSearchResult(TableInfo* ti, int found)
{
       printf("Hash %02x %02x %02x ", hash[0], hash[1], hash[2]);
       if (found==0) {
          printf("bol v tabulke najdeny\n");
          printf("Vzor pre tento hash je:\n      ");
          unsigned char* key;
          key = (unsigned char *)(ti->pKey);
          printf("%02x %02x %02x\n", key[0], key[1], key[2]);
          free(ti->pKey);
          printf("ROW:  %d\n", ti->row);
          printf("COL:  %d\n", ti->column);     
       } else
          printf("nebol v tabulke najdeny\n");
       printf("FAL:  %d\n", ti->false_alarms);
       printf("NENC: %d\n", ti->nencode);
       printf("FENC: %d\n", ti->false_nencode);
       printf("NRED: %d\n", ti->nreduce);
       printf("FRED: %d\n", ti->false_nreduce);
       printf("NCMP: %d\n", ti->ncompare);
       unsigned char str[15];
       timeToString(&(ti->search_time), str);
       printf("Cas hladania: %s\n", str);
}

static int checkParametersForUpgrade(TableInfo* ti)
{
       if (ti->table_name == "") return 1;
       if (ti->table_size < 1) return 2;
       if (ti->chain_length < 1) return 3;
       if (ti->array_size < 10) return 4;
       return 0;
}

static void reportParametersProblem(int errnum)
{
       if (errnum==5) return;
       printf("Problem s parametrom ");
       switch (errnum) {
              case 1:
                   printf("table_name\n");
                   break;
              case 2:
                   printf("table_size\n");
                   break;
              case 3:
                   printf("chain_length\n");
                   break;
              case 4:
                   printf("array_size\n");
                   break;
       }
}

static void reportCrProblem(int errnum)
{
       switch (errnum) {
              case 1:
                   printf("Nedostatocna velkost pola.");
                   break;
              case 2:
                   printf("Pole sa nepodarilo alokovat.");
                   break;
              case 3:
                   printf("Problem pri praci so suborom.");
                   break;
              // 4 - problem with parameter; not in this application
       }
}

static void reportCreateProblem(int errnum)
{
       printf("Pocas vytvarania tabuliek nastal problem: ");
       reportCrProblem(errnum);
       printf("\n");
}

static void reportUpgradeProblem(int errnum)
{
       printf("Pocas rozsirovania tabuliek nastal problem: ");
       if (errnum<4) reportCrProblem(errnum);
       if (errnum == 5) printf("Tabulka nebola najdena");
       printf("\n");
}

static void reportSuccessfulCreate(const TableInfo* ti)
{
       printf("\n");
       printf("Tabulka bola uspesne vytvorena\n");
       printf("Velkost vytvorenej tabulky je: %d\n", ti->chains);
       printf("Pocas vytvarania bolo zahodenych %d retazi\n", ti->collisions);
}

static void reportSuccessfulUpgrade(const TableInfo* ti)
{
       printf("\n");
       printf("Tabulka bola uspesne zvacsena\n");
       printf("Pocet pridanych retazi do tabulky je: %d\n", ti->chains);
       printf("Pocas zvacsovania bolo zahodenych %d retazi\n", ti->collisions);       
}

static void reportSearching(int tmp, int k, my_time search_time)
{
       printf("%d z %d hladani bolo uspesnych\n", tmp, k);
       int mil;
       mil = (1000*search_time.sec) + search_time.millisec;
       mil /= k;
       printf("Priemerny cas hladanie: %d.%d sekund\n", mil / 1000, mil % 1000);
}


static void printThree(void* p)
{
      printf("%02x ", ((unsigned char*)p)[0]);
      printf("%02x ", ((unsigned char*)p)[1]);
      printf("%02x ", ((unsigned char*)p)[2]);
      printf("\n");
}

static void drawProgressBar()
{
       system("cls");
       int i;
       printf("Prehladava sa: ");
       for (i=0; i<prog_i; i++) printf("%c", 219);
       for(i=prog_i; i<20; i++) printf("%c", 177);
}

static void initProgressBar(int max)
{
       prog_max = max;
       prog_count = 0;
       prog_i = 0;
       drawProgressBar();
}

static void updateProgressBar()
{
       prog_count++;
       int a;
       a = (100*prog_count)/prog_max;
       a /= 5;
       if (a>prog_i) {
          prog_i = a;
          drawProgressBar();
       }
}

int main(int argc, char *argv[])
{
    hash[0] = 0;
    hash[1] = 0;
    hash[2] = 0;
    TableInfo ti;
    resetTableInfo(&ti);
//    ti.fGenerateKey = &genKey;
    int action;
    int n, tmp, k;
    int errnum; // error number
    randomize20(time(NULL));
    my_time search_time;
    while (1) {
      if ( (action = titleScreen(&ti)) == 0) break;
      if (action  == 1) {       
         // Loading from file
         loadFromFile(&ti, FILE_NAME1);
      } else 
      if (action  == 2) {       
         // Saving to file
         saveToFile(&ti, FILE_NAME1);
      } else 
      if (action == 3) {
         // Enter input parameters manually
         do {
           action = loadParameters(&ti);
           printf("%d ", action);
         } while ((action<0)||(action>2));
         if (action == 1) {
            // all parameters
            loadAllParameters(&ti);
         } else
         if (action == 2) {
            loadParametersByOne(&ti);
         }
         showParameters(&ti);
         action = 0;
      } else
      if (action == 4){
         // Create table
         if (! (errnum = checkParametersForCreate(&ti))){
            if (errnum = createTable(&ti)){
               // error of some sort
               reportCreateProblem(errnum);
            } else {
               // all OK
               reportSuccessfulCreate(&ti);
            }            
         } else {
           reportParametersProblem(errnum);
         }
      } else 
      if (action == 5) {
         saveToTextfile(&ti, FILE_NAME2);         
      } else
      if ( (action == 6) && (project_exists) ){
         // upgrade table
         loadMainParameters(&ti, 0);
         if (! (errnum = checkParametersForUpgrade(&ti))){
            errnum = upgradeTable(&ti);
            if ((errnum)&&(errnum<6))
               reportUpgradeProblem(errnum);
            else
               reportSuccessfulUpgrade(&ti);
         } else {
           reportParametersProblem(errnum);         
         }
      } else 
      if ( (action == 7) && (project_exists) ) {
         // search table
         loadMainParameters(&ti, 1);
         do {
            action = searchTableMenu(&ti);
            if (action==2) {
               loadHash();
               action = -1; // 
            }
         } while ((action<0)||(action>3));
         if (action == 1) {
            printSearchResult(&ti, searchTable(&ti, hash));
         } else
         if (action == 3){
            // search N hashes
            k = n = getNumber();
            initProgressBar(n);
            tmp = 0;
            resetTime(&search_time);
            while (n-- > 0) {                  
                  loadRandomHash();
                  errnum = searchTable(&ti, hash);
                  timeSum(&search_time, ti.search_time); // for counting average searching time
                  updateProgressBar();
                  if (! errnum) {
                      tmp++;
                      free(ti.pKey);
                  }
                  if (action) {
                     saveToTextfile2(&ti, FILE_NAME3, "w", hash);
                     action = 0;
                  } else
                     saveToTextfile2(&ti, FILE_NAME3, "a", hash);
            }
            system("cls");
            reportSearching(tmp, k, search_time);
            
         }
         action = 0;
      } else 
      if ( (action == 8) && (project_exists) ) {
         loadMainParameters(&ti, 1);
      }
    }
//    system("PAUSE");	
    return 0;
}
