#include "my_timer.h"
#include <stdlib.h>

void now(my_time *m)
{
     struct timeb t;
     ftime(&t);
     m->sec = t.time;
     m->millisec = t.millitm;
}

void resetTime(my_time *m)
{
     m->sec = m->millisec = 0;
}

void timeDifference(my_time m1, my_time m2, my_time *m3)
{
     m3->sec = m2.sec - m1.sec;
     m3->millisec = m2.millisec - m1.millisec;
     if (m3->millisec >=  1000) {m3->sec++; m3->millisec -= 1000;}
     if (m3->millisec <= -1000) {m3->sec--; m3->millisec += 1000;}
     if ((m3->sec<0)&&(m3->millisec>0)) {m3->sec++; m3->millisec = 1000 - m3->millisec;}
     if ((m3->sec>0)&&(m3->millisec<0)) {m3->sec--; m3->millisec = 1000 + m3->millisec;}    
}

void timeSum(my_time *m1, my_time m2)
{
     m1->millisec += m2.millisec;
     m1->sec += m2.sec;
     if (m1->millisec>999) {
        m1->millisec -= 1000;
        m1->sec++;        
     }
     
}

void timeToString(const my_time* m, unsigned char* buffer)
{
      sprintf(buffer, "%d.", m->sec);
      unsigned char ms[4];
      if (m->millisec > 1000){
         sprintf(ms, "000");
      } else
      if (m->millisec<10) {         
         sprintf(ms, "00%d", m->millisec);
      } else
      if (m->millisec<100) {
         sprintf(ms, "0%d", m->millisec);
      } else
         sprintf(ms, "%d", m->millisec);
      strcat(buffer, ms);
}
